[LeetCode] 219. 存在重复元素 II

题目描述:

给你一个整数数组 nums 和一个整数 k ,判断数组中是否存在两个 不同的索引 i 和j ,满足 nums[i] == nums[j] 且 abs(i - j) <= k 。如果存在,返回 true ;否则,返回 false 。

示例 1:

复制代码
输入:nums = [1,2,3,1], k = 3
输出:true

示例 2:

复制代码
输入:nums = [1,0,1,1], k = 1
输出:true

示例 3:

复制代码
输入:nums = [1,2,3,1,2,3], k = 2
输出:false

题目链接:

. - 力扣(LeetCode)

解题主要思想:

其实这道题跟 "两数之和" 有点像,但需要注意的是,题目说的是<= k,因此我们需要尽可能地缩小i和j的距离,但如果是>= k,那我们就需要尽可能地增大i和j的距离,解决办法就是只记录第一次发现numsi时的下标。

两数之和链接:
LeetCode 1. 两数之和-CSDN博客

解题代码:

cpp 复制代码
class Solution {
public:
    bool containsNearbyDuplicate(vector<int>& nums, int k) {
        unordered_map<int, int> map;
        for(int i = 0; i < nums.size(); ++i) {
            if (map.count(nums[i])) {
                if ((i-map[nums[i]]) <= k) return true;
            }
            map[nums[i]] = i;  // 如果是>= k,那么就需要加上在这行代码最前面加上else
        }
        return false;
    }
};
相关推荐
WL学习笔记1 小时前
vector模拟实现
c++
蜗牛一步步往上爬3 小时前
第十六章 C++语言在深度学习中的应用
开发语言·c++·深度学习
likexuec6 小时前
数据结构(2)
数据结构
文丑颜不良啊6 小时前
LeetCode2221~2240题目解析
java·leetcode
Navigator_Z7 小时前
LeetCode //C - 1317. Convert Integer to the Sum of Two No-Zero Integers
c语言·算法·leetcode
wo_jack7 小时前
C++ 入门笔记(十六):第16课 vector 模拟实现十问十答 —— 从三指针到迭代器失效
c++·后端·面试·stl·vector
D e re k ZH7 小时前
C++ 标准库算法全景指南
数据结构·c++·算法
冻柠檬飞冰走茶8 小时前
字母移动游戏题解:贪心求最长可保留连续子串(附 C 实现)
c语言·开发语言·数据结构·算法·动态规划
文丑颜不良啊8 小时前
LeetCode2161~2180题目解析
java·leetcode